###################################################
## Pilot Generator 2.1b for the Jfile database update v2.1
## By Nick Smith
## http://home1.inet.tele.dk/nsa
## smith@post1.tele.dk

#####################  FILE LIST & LONG NAME LIST #####################
#
#
#	If you are not familliar with Perl, these squares (#) 
#	mean "comment" they stop lines of text being included
#	as part of the program's code.
#
#
#	Below is a list of file-names, followed by a long name
#	(discription) that will appear in the title of each report
#	As you can see, the filename is in the short DOS format,
#	minus the dot and the extension.
#	See the Pilot Generator homepage for installation instructions 



@file_array = ( 
# DATABASE 1
"LOF-SE~1",	#<--- this is a filname within the quotes
"LOF EDB SERVICE OPGAVER", # <----this is it's long-name, also within the quotes.

# DATABASE 2
"LOF-EK~1",
"EKSTERN OPGAVER (TIL FAKTURERING)",

# DATABASE 3
"LOF-AN~1",
"ANDRE - ikke edb - LOF OPGAVER"



); ## This is the end of the file list
   ## Make sure that for every file-name, there is a long-name


###############   VARIABLES FOR REPORT STYLES  ###############

$header_size = 1; ## Choose a size 1 - 6, 1 is the largest

$border = 2;  	# Values 0, no border. 1 border size of 1 ...etc
		# This will print table borders in the report


### Declare Functions and system calls

sub make_index;
sub convert_file;  
sub create_html_header;
sub print_table;
sub make_html;


print ("Welcome to Generator, the Pilot Report generator v.1b\n");


@file_array = &convert_file(@file_array);

@file_array = &make_html;

&make_index(@file_array);





################  Function: call Jconv to create the .CSV files  ################
sub convert_file 
	{  	
	$total_files = @file_array; # actually divided by 2 because of the long-titles
	$file_count = 0;

	while ($file_count < $total_files) 
	{

		$input = @file_array[$file_count];
		$filename = $input . ".pdb";
		$output = $input . ".csv";
		@proglist = ("jconv.exe", "2", $filename, $output);
		system (@proglist);
		@file_array[$file_count] = $output;

	$file_count++; $file_count++; 	## Here the counter is increased twice, to jump over
					## the *long title* of the file, to the next file
	}

	return @file_array;
} 





################  Function: Write the HTML file HEADER ##########################
sub create_html_header 
      {
	$title = $title;
	$htmlfile = $file . "htm";

	open(HTMLFILE, ">$htmlfile");


	print HTMLFILE ("<HTML><HEAD><TITLE>$title</TITLE>\n");
	print HTMLFILE ("</HEAD><BODY BGCOLOR=\"FFFFFF\">\n");
	print HTMLFILE ("<H$header_size>$title</H$header_size><P><TABLE BORDER=$border>\n");

	
	&print_table(HTMLFILE,$file);
	close(HTMLFILE);
       }





################  Function: print table header         ##########################
sub print_table {
	$inputfile = $file . "csv";
	open(INPUT, $inputfile); 	# Open the input file for reading.

	$line = <INPUT>;

while ($line ne "") 
	{
	@array = split(/","/, $line);
	$size = @array;
	$count =0;
	print HTMLFILE  "<TR>";

		while($count < $size) 
			{
			@array[$count] =~ s/\"//g;
			print HTMLFILE ("<TD> <B>@array[$count] </TD>");
			$count++;
			
			}

	print HTMLFILE "</TR>";
	$line = <INPUT>;
	}
print HTMLFILE "</TABLE><P><A HREF=\"index.htm\">Back to the List</A></BODY></HTML>\n";	# End writing with the HTML footer.

}
################  Function: Create the HTML files      ##########################
sub make_html {
	$total_files = @file_array; 
	$file_count = 0;
	while ($file_count < $total_files) 
		{
		$filetemp = @file_array[$file_count];	# We now have the file

		$file = $filetemp;		# $file is used for changing the filename
						# $filetemp is used to remember the complete
						# filename AND the extention (.csv)

		$title = @file_array[$file_count+1];	# We now have the Long Name - Title.

		#chop the file 3 times to remove the CSV extention...
		chop($file); chop($file); chop($file);

		# now call the function to create the file,
		# and write the header, and the title!!

		&create_html_header($title,$file); 	
		
	$file_count++; $file_count++;
	}
return @file_array;
}

##################  Function: Make Index File ###################################

sub make_index {
open (INDEX, ">index.htm");
print INDEX ("<HTML><HEAD><TITLE>Pilot Report Generator 1.0 by Nick Smith</TITLE></HEAD>");
print INDEX ("<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000080\" LINK=\"#FF0000\"><TABLE BORDER=0><TR>");
print INDEX ("<TD><H1>Pilot Report Generator 1b by Nick Smith</H1><H2>Pilot Report Generator has made your report(s).</H2></TD>");
print INDEX ("</TR></TABLE><H3>Follow the links below to read and print your report(s).</H3><HR><P>");


$total_files = @file_array; 
	$file_count = 0;

	while ($file_count < $total_files) 
		{
		$temp =@file_array[$file_count];
		chop($temp); chop($temp); chop($temp);
		@file_array[$file_count] = $temp . "htm";
		print INDEX ("<A HREF=\"@file_array[$file_count]\">@file_array[$file_count+1]</A><P>");
		$file_count++; $file_count++;
		}
print INDEX ("<H4>When you wish to <B>Print</B> your reports, simply click on the Print ikon on your browser's toolbar.</H4></BODY></HTML>");
close(INDEX);
}